{
===============================================================================
  Copyright (©) 2001. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 01-10-2001
  Versión actual: 1.0.0
  Fecha versión actual: 01-10-2001
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit BuscarAlbaranCliente;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  RdxFrameAlbaranes, RdxBotones, ExtCtrls, StdCtrls, RdxCampos,
  RdxTitulos, RdxPaneles, RdxBarras;

type
  TfrBuscarAlbaranCliente = class(TRdxFrameAlbaranes)
    brBuscar: TRdxBarraInferior;
    bBuscar: TRdxBoton;
    bCerrar: TRdxBoton;
    pnlScroll: TRdxScrollPanel;
    cBuscarCliente: TRdxCabecera;
    eCodigoPedido: TLabel;
    Codigo: TRdxEdit;
    eNIF: TLabel;
    NIF: TRdxEdit;
    eNombre: TLabel;
    Nombre: TRdxEdit;
    eCodigoProveedor: TLabel;
    CodigoCliente: TRdxEdit;
    procedure bBuscarClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
  private
    procedure RecogerDatos;
  protected
    procedure BuscarAlbaran; override;
    function CloseFrame : boolean; override;
  public
    constructor Create(AOwner : TComponent); override;
  end;

var
  frBuscarAlbaranCliente: TfrBuscarAlbaranCliente;

implementation
{$R *.DFM}

uses
  Tipos, Mensajes, StrFunc, Configuracion, DB, Literales;

var
  Campos : String;
  Valores : Variant;
  Contador : Integer;

procedure TfrBuscarAlbaranCliente.bBuscarClick(Sender: TObject);
begin
  RecogerDatos;
  if Contador <> -1 then
    BuscarAlbaran
  else
    VerMensaje(msgNoParametros);
end;

procedure TfrBuscarAlbaranCliente.bCerrarClick(Sender: TObject);
begin
  CloseFrame;
end;

procedure TfrBuscarAlbaranCliente.BuscarAlbaran;
var
  Respuesta : integer;
  Resultado : Boolean;
begin
  if Contador <> -1 then begin
    TablaAlbaranes.DisableControls;

    if Contador = 0 then
      Resultado := TablaAlbaranes.LocateNext(Campos, Valores[Contador], [loCaseInsensitive, loPartialKey])
    else
      Resultado := TablaAlbaranes.LocateNext(Campos, Valores, [loCaseInsensitive, loPartialKey]);
    if (Resultado = false) then
    begin
        Respuesta := VerMensajePregunta(msgIrInicio);
        case Respuesta of
          IDYES: TablaAlbaranes.First;
        end;
    end;
    TablaAlbaranes.EnableControls;
  end;
end;

function TfrBuscarAlbaranCliente.CloseFrame: boolean;
begin
  FCodigoAlbaran := TablaAlbaranes.FieldByName('CODIGO').AsString;
  Result := inherited CloseFrame;
end;

constructor TfrBuscarAlbaranCliente.Create(AOwner: TComponent);
begin
  if not (AOwner is TRdxFrameAlbaranes) then
    exit;
  inherited Create(AOwner);
  Entidad := entAlbaranCliente;
  ConfigurarFrame(Self, Self.Entidad);

  Contador := -1;
  Campos := '';
  Valores := VarArrayOf([null, null, null, null]);

  TablaAlbaranes := (AOwner as TRdxFrameAlbaranes).TablaAlbaranes;
  with TablaAlbaranes do begin
    Codigo.MaxLength := FieldByName('CODIGO').Size;
    Nombre.MaxLength := FieldByName('NOMBRE').Size;
    CodigoCliente.MaxLength := FieldByName('CODIGOCLIENTE').Size;
    NIF.MaxLength := FieldByName('NIFCIF').Size;
  end;
end;

procedure TfrBuscarAlbaranCliente.RecogerDatos;
begin
  Campos := '';
  Contador := -1;

  if not EsCadenaVacia(Codigo.Text) then
  begin
    Contador := Contador + 1;
    Campos := Campos + 'CODIGO';
    Valores[Contador] := Trim(Codigo.Text);
  end;

  if not EsCadenaVacia(CodigoCliente.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'CODIGOCLIENTE';
    Valores[Contador] := Trim(CodigoCliente.Text);
  end;

  if not EsCadenaVacia(Nombre.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NOMBRE';
    Valores[Contador] := Trim(Nombre.Text);
  end;

  if not EsCadenaVacia(Nif.Text) then
  begin
    Contador := Contador + 1;
    if Contador > 0 then
      Campos := Campos + ';';
    Campos := Campos + 'NIFCIF';
    Valores[Contador] := Trim(Nif.Text);
  end;
end;

end.
